#!/usr/bin/env python3
# -*- coding:utf-8 -*-
import webiopi							
import datetime
import json
import sys
import time
import os
import subprocess
import re

# отправка e-mail:
import smtplib
from email.mime.text import MIMEText
from email.mime.multipart import MIMEBase
from email.mime.multipart import MIMEMultipart
from email.mime.image import MIMEImage
from email.mime.audio import MIMEAudio
from email.header import Header
from base64 import encodebytes
import email
import mimetypes


#pressure, celsius, celsius_1, celsius_2 = 0, 0, 0, 0

from subprocess import call
	
from time import strftime

#from webiopi import deviceInstance	

# Инициализация датчика BMP085
from webiopi.devices.sensor.bmp085 import BMP085


## Инициализация датчика TSL2561
from webiopi.devices.sensor.tslXXXX import TSL2561
light0 = TSL2561()

# Инициализации двух датчиков DS18B20 с чтением их id 

from webiopi.devices.sensor.onewiretemp import DS18B20
f = open('/home/pi/myproject/html/logs/config.txt')
line = f.readlines()
id_18b20_1 = line[49]
id_18b20_1 = id_18b20_1.rstrip()		# удаление символа перевода строки
id_18b20_2 = line[50]
id_18b20_2 = id_18b20_2.rstrip()
f.close()
tmp1 = DS18B20(slave=id_18b20_1)
tmp2 = DS18B20(slave=id_18b20_2)


GPIO = webiopi.GPIO

GPIO.setFunction(21, GPIO.OUT)						# ВЫХОД ТЕРМОСТАТА 1
GPIO.setFunction(20, GPIO.OUT) 						# ВЫХОД ТЕРМОСТАТА 2
GPIO.setFunction(16, GPIO.OUT)
GPIO.setFunction(12, GPIO.OUT)
GPIO.setFunction(7, GPIO.OUT)	
GPIO.setFunction(8, GPIO.OUT)	
GPIO.setFunction(25, GPIO.OUT)	
GPIO.setFunction(24, GPIO.OUT)	
	
GPIO.setFunction(23, GPIO.IN)	
GPIO.setFunction(18, GPIO.IN)		
GPIO.setFunction(22, GPIO.IN)	
GPIO.setFunction(5, GPIO.IN)	
GPIO.setFunction(6, GPIO.IN)	
GPIO.setFunction(13, GPIO.IN)	
GPIO.setFunction(19, GPIO.IN)	
GPIO.setFunction(26, GPIO.IN)

GPIO.setFunction(10, GPIO.IN,GPIO.PUD_UP)	
GPIO.setFunction(9, GPIO.IN,GPIO.PUD_UP)	
GPIO.setFunction(11, GPIO.IN,GPIO.PUD_UP)		
	
	
# флаг записи старта/рестата WebIOPi
start = 0	
	
	
	
	
	
# флаги однократной записи в журнал выходов
a1 = 1	
b1 = 1 
a2 = 1	
b2 = 1 
a3 = 1	
b3 = 1 
a4 = 1	
b4 = 1 
a5 = 1	
b5 = 1 
a6 = 1	
b6 = 1 
a7 = 1	
b7 = 1 
a8 = 1	
b8 = 1 

# флаги однократной записи в журнал входов
c1 = 1
d1 = 1
c2 = 1
d2 = 1
c3 = 1
d3 = 1
c4 = 1
d4 = 1
c5 = 1
d5 = 1
c6 = 1
d6 = 1
c7 = 1
d7 = 1
c8 = 1
d8 = 1



# флаги однократной записи в журнал выходов при работе от термостата
e1 = 1	
f1 = 1 
e2 = 1	
f2 = 1

# флаги однократной записи в журнал выходов при работе от люксметра
j1 = 1	
k1 = 1 
j2 = 1	
k2 = 1

# флаги однократной записи в журнал выходов привязки входов 7 и 8 к выходам 7 и 8
e7 = 1	
f7 = 1 
e8 = 1	
f8 = 1


# флаги отправки е-mail при событиях на входах

in_1_mail_close = 0
in_1_mail_open = 0
in_2_mail_close = 0
in_2_mail_open = 0
in_3_mail_close = 0
in_3_mail_open = 0
in_4_mail_close = 0
in_4_mail_open = 0
in_5_mail_close = 0
in_5_mail_open = 0
in_6_mail_close = 0
in_6_mail_open = 0
in_7_mail_close = 0
in_7_mail_open = 0
in_8_mail_close = 0
in_8_mail_open = 0


# минимальная и максимальная температура

on_t_1 = 0
min_t_1 = 0
max_t_1 = 0

on_t_2 = 0
min_t_2 = 0
max_t_2 = 0



# минимальная и максимальная освещенность 

on_lux_1 = 0
min_lux_1 = 0
max_lux_1 = 0



# время включения и отключения таймеров

time_1_on = 0
hour_1_start = 0
minute_1_start = 0
hour_1_stop = 0
minute_1_stop = 0

time_2_on = 0
hour_2_start = 0
minute_2_start = 0
hour_2_stop = 0
minute_2_stop = 0


# входы

on_in_7 = 0
on_in_8 = 0
 
INPUT_1 = 23
INPUT_2 = 18
INPUT_3 = 22
INPUT_4 = 5
INPUT_5 = 6
INPUT_6 = 13
INPUT_7 = 19
INPUT_8 = 26

#выходы

OUT_1 = 21 
OUT_2 = 20
OUT_3 = 16
OUT_4 = 12 
OUT_5 = 7
OUT_6 = 8
OUT_7 = 25 
OUT_8 = 24

ch_1 = 0
ch_2 = 0
ch_3 = 0
ch_4 = 0
ch_5 = 0
ch_6 = 0
ch_7 = 0
ch_8 = 0
	
def setup():

    global text_1, on_t_1, min_t_1, max_t_1, on_t_2, min_t_2, max_t_2, ust_1_on,\
    ust_1_min, ust_1_max, ust_2_on, ust_2_min, ust_2_max, on_in_7, on_in_8,\
    in_1_mail_close, in_1_mail_open, in_2_mail_close, in_2_mail_open, in_3_mail_close, in_3_mail_open, in_4_mail_close, in_4_mail_open,\
    in_5_mail_close, in_5_mail_open, in_6_mail_close, in_6_mail_open, in_7_mail_close, in_7_mail_open, in_8_mail_close, in_8_mail_open,\
    time_1_on,hour_1_start,minute_1_start,hour_1_stop,minute_1_stop,time_2_on,hour_2_start,minute_2_start,hour_2_stop,minute_2_stop,\
    on_lux_1, min_lux_1, max_lux_1, sensor_1, sensor_2, sensor_3, sensor_4, sensor_5, sensor_6, sensor_7, sensor_8,\
    sensor_9, sensor_10, sensor_11, sensor_12, sensor_13, sensor_14, sensor_15, sensor_16,\
    id_18b20_1,id_18b20_2,id_18b20_3,id_18b20_4,id_18b20_5,id_18b20_6,id_18b20_7,id_18b20_8,id_18b20_9,id_18b20_10,\
    text_mail_1_close,text_mail_1_open,text_mail_2_close,text_mail_2_open,text_mail_3_close,text_mail_3_open,text_mail_4_close,text_mail_4_open,\
    text_mail_5_close,text_mail_5_open,text_mail_6_close,text_mail_6_open,text_mail_7_close,text_mail_7_open,text_mail_8_close,text_mail_8_open,\
    mail_to,mail_from,smtp_server,smtp_user,smtp_pwd,reserve,ch_1,ch_2,ch_3,ch_4,ch_5,ch_6,ch_7,ch_8
 
    f = open('/home/pi/myproject/html/logs/config.txt')
	
    on_t_1 = f.readline()
    on_t_1 = float(on_t_1)
    min_t_1 = f.readline()
    min_t_1 = float(min_t_1)
    max_t_1 = f.readline()
    max_t_1 = float(max_t_1)
	
    on_t_2 = f.readline()
    on_t_2 = float(on_t_2)		
    min_t_2 = f.readline()
    min_t_2 = float(min_t_2)
    max_t_2 = f.readline()
    max_t_2 = float(max_t_2)
	
    on_in_7 = f.readline()	
    on_in_7 = float(on_in_7)
    on_in_8 = f.readline()	
    on_in_8 = float(on_in_8)
	
    in_1_mail_close = f.readline()
    in_1_mail_close = float(in_1_mail_close)
    in_1_mail_open = f.readline()
    in_1_mail_open = float(in_1_mail_open)	
	
    in_2_mail_close = f.readline()
    in_2_mail_close = float(in_2_mail_close)
    in_2_mail_open = f.readline()
    in_2_mail_open = float(in_2_mail_open)		
	
    in_3_mail_close = f.readline()
    in_3_mail_close = float(in_3_mail_close)
    in_3_mail_open = f.readline()
    in_3_mail_open = float(in_3_mail_open)		
	
    in_4_mail_close = f.readline()
    in_4_mail_close = float(in_4_mail_close)
    in_4_mail_open = f.readline()
    in_4_mail_open = float(in_4_mail_open)	
	
    in_5_mail_close = f.readline()
    in_5_mail_close = float(in_5_mail_close)
    in_5_mail_open = f.readline()
    in_5_mail_open = float(in_5_mail_open)	
	
    in_6_mail_close = f.readline()
    in_6_mail_close = float(in_6_mail_close)
    in_6_mail_open = f.readline()
    in_6_mail_open = float(in_6_mail_open)	

    in_7_mail_close = f.readline()
    in_7_mail_close = float(in_7_mail_close)
    in_7_mail_open = f.readline()
    in_7_mail_open = float(in_7_mail_open)	

    in_8_mail_close = f.readline()
    in_8_mail_close = float(in_8_mail_close)
    in_8_mail_open = f.readline()
    in_8_mail_open = float(in_8_mail_open)	
	
	
    time_1_on = f.readline()
    time_1_on = float(time_1_on)
	
    s = f.readline()
    hour_1_start = s[0:2]
    hour_1_start = float(hour_1_start)
    minute_1_start = s[3:5]
    minute_1_start = float(minute_1_start)

    s = f.readline()
    hour_1_stop = s[0:2]
    hour_1_stop = float(hour_1_stop)
    minute_1_stop = s[3:5]
    minute_1_stop = float(minute_1_stop)


    time_2_on = f.readline()
    time_2_on = float(time_2_on)
	
    s = f.readline()
    hour_2_start = s[0:2]
    hour_2_start = float(hour_2_start)
    minute_2_start = s[3:5]
    minute_2_start = float(minute_2_start)

    s = f.readline()
    hour_2_stop = s[0:2]
    hour_2_stop = float(hour_2_stop)
    minute_2_stop = s[3:5]
    minute_2_stop = float(minute_2_stop)
		

		
    on_lux_1 = f.readline()
    on_lux_1 = float(on_lux_1)
    min_lux_1 = f.readline()
    min_lux_1 = float(min_lux_1)
    max_lux_1 = f.readline()
    max_lux_1 = float(max_lux_1)		
		
		
    sensor_1 = f.readline()
    sensor_1 = float(sensor_1)
    sensor_2 = f.readline()
    sensor_2 = float(sensor_2)
    sensor_3 = f.readline()
    sensor_3 = float(sensor_3)
    sensor_4 = f.readline()
    sensor_4 = float(sensor_4)
    sensor_5 = f.readline()
    sensor_5 = float(sensor_5)
    sensor_6 = f.readline()
    sensor_6 = float(sensor_6)
    sensor_7 = f.readline()
    sensor_7 = float(sensor_7)
    sensor_8 = f.readline()
    sensor_8 = float(sensor_8)

    sensor_9 = f.readline()
    sensor_9 = float(sensor_9)
    sensor_10 = f.readline()
    sensor_10 = float(sensor_10)
    sensor_11 = f.readline()
    sensor_11 = float(sensor_11)
    sensor_12 = f.readline()
    sensor_12 = float(sensor_12)
    sensor_13 = f.readline()
    sensor_13 = float(sensor_13)
    sensor_14 = f.readline()
    sensor_14 = float(sensor_14)
    sensor_15 = f.readline()
    sensor_15 = float(sensor_15)
    sensor_16 = f.readline()
    sensor_16 = float(sensor_16)
	
    id_18b20_1 = f.readline()
    id_18b20_1 = id_18b20_1.rstrip()		# удаление символа перевода строки
    id_18b20_2 = f.readline()
    id_18b20_1 = id_18b20_1.rstrip()	
    id_18b20_3 = f.readline()
    id_18b20_1 = id_18b20_1.rstrip()	
    id_18b20_4 = f.readline()
    id_18b20_1 = id_18b20_1.rstrip()	
    id_18b20_5 = f.readline()
    id_18b20_1 = id_18b20_1.rstrip()
    id_18b20_6 = f.readline()
    id_18b20_1 = id_18b20_1.rstrip()	
    id_18b20_7 = f.readline()
    id_18b20_1 = id_18b20_1.rstrip()	
    id_18b20_8 = f.readline()
    id_18b20_1 = id_18b20_1.rstrip()	
    id_18b20_9 = f.readline()
    id_18b20_1 = id_18b20_1.rstrip()	
    id_18b20_10 = f.readline()
    id_18b20_1 = id_18b20_1.rstrip()	
	
    text_mail_1_close = f.readline()	
    text_mail_1_open = f.readline()	
    text_mail_2_close = f.readline()	
    text_mail_2_open = f.readline()		
    text_mail_3_close = f.readline()	
    text_mail_3_open = f.readline()		
    text_mail_4_close = f.readline()	
    text_mail_4_open = f.readline()		
    text_mail_5_close = f.readline()	
    text_mail_5_open = f.readline()
    text_mail_6_close = f.readline()	
    text_mail_6_open = f.readline()
    text_mail_7_close = f.readline()	
    text_mail_7_open = f.readline()
    text_mail_8_close = f.readline()	
    text_mail_8_open = f.readline()		

    mail_to = f.readline()
    mail_to = mail_to.rstrip()
    mail_from = f.readline()
    mail_from = mail_from.rstrip()
    smtp_server = f.readline()
    smtp_server = smtp_server.rstrip()	
    smtp_user = f.readline()
    smtp_user = smtp_user.rstrip()
    smtp_pwd = f.readline()
    smtp_pwd = smtp_pwd.rstrip()

    reserve = f.readline()
    reserve = float(reserve)	
	
    ch_1 = f.readline()
    ch_1 = float(ch_1)
    ch_2 = f.readline()
    ch_2 = float(ch_2)
    ch_3 = f.readline()
    ch_3 = float(ch_3)
    ch_4 = f.readline()
    ch_4 = float(ch_4)
    ch_5 = f.readline()
    ch_5 = float(ch_5)
    ch_6 = f.readline()
    ch_6 = float(ch_6)
    ch_7 = f.readline()
    ch_7 = float(ch_7)	
    ch_8 = f.readline()
    ch_8 = float(ch_8)
	
    f.close()	
		
def set_out():	
    if on_t_1 == 0:
        GPIO.digitalWrite(21, GPIO.HIGH)	
        	

		
    if on_t_2 == 0:
        GPIO.digitalWrite(20, GPIO.HIGH)
		
    if on_lux_1 == 0:
        GPIO.digitalWrite(7, GPIO.HIGH)		


		
    if on_in_7 == 0:
        GPIO.digitalWrite(25, GPIO.HIGH)	
		
    if on_in_8 == 0:
        GPIO.digitalWrite(24, GPIO.HIGH)				
			

	
	

	
def loop():

    setup() # чтение конфигурации из файла (для нормальной работы script_sms)
#============================ КОНТРОЛЬ СТАРТА (РЕСТАРТА ====================================

    global start
   
    if start == 0:
        text_1 = " Restart Web Home Pi"	
        writing_input()
        #if in_1_mail_close == 1:
           #sendmail()	
        start = 1
    #else:
        #pass


#============================ КОНТРОЛЬ ВХОДОВ ====================================

    global c1, c2, c3, c4, c5, c6, c7, c8, d1, d2, d3, d4,  d5, d6, d7, d8, mail_text 

    #text_mail_1_close = "Test email close Web Home Pi"	
		
	
# Вход 1===================================
	
    if (int(GPIO.digitalRead(INPUT_1))) == 0:   # контроль входа 1
        d1 = 0
        if c1 == 0:
            text_1 = " Input 1 Close"	
            writing_input()
            if in_1_mail_close == 1:
                mail_text = text_mail_1_close			
                sendmail()	
            c1 = 1
        #else:
            #pass	
		
    if (int(GPIO.digitalRead(INPUT_1))) == 1:
        c1 = 0
        if d1 == 0:
            text_1 = " Input 1 Open"	
            writing_input()
            if in_1_mail_open == 1:	
                mail_text = text_mail_1_open			
                sendmail()			
            d1 = 1
        #else:
            #pass	
		
# Вход 2===================================
	
    if (int(GPIO.digitalRead(INPUT_2))) == 0:   # контроль входа 2
        d2 = 0
        if c2 == 0:
            text_1 = " Input 2 Close"	
            writing_input()
            if in_2_mail_close == 1:
                mail_text = text_mail_2_close			
                sendmail()			
            c2 = 1
        #else:
            #pass	
		
    if (int(GPIO.digitalRead(INPUT_2))) == 1:
        c2 = 0
        if d2 == 0:
            text_1 = " Input 2 Open"	
            writing_input()
            if in_2_mail_open == 1:
                mail_text = text_mail_2_open
                sendmail()				
            d2 = 1
        #else:
            #pass	
	
	
# Вход 3===================================
	
    if (int(GPIO.digitalRead(INPUT_3))) == 0:   # контроль входа 3
        d3 = 0
        if c3 == 0:
            text_1 = " Input 3 Close"	
            writing_input()
            if in_3_mail_close == 1:
                mail_text = text_mail_3_close			
                sendmail()				
            c3 = 1
        #else:
            #pass	
		
    if (int(GPIO.digitalRead(INPUT_3))) == 1:
        c3 = 0
        if d3 == 0:
            text_1 = " Input 3 Open"	
            writing_input()
            if in_3_mail_open == 1:
                mail_text = text_mail_3_open
                sendmail()				
            d3 = 1
        #else:
            #pass	
	
# Вход 4===================================
	
    if (int(GPIO.digitalRead(INPUT_4))) == 0:   # контроль входа 4
        d4 = 0
        if c4 == 0:
            text_1 = " Input 4 Close"	
            writing_input()
            if in_4_mail_close == 1:
                mail_text = text_mail_4_close
                sendmail()			
            c4 = 1
        #else:
            #pass	
		
    if (int(GPIO.digitalRead(INPUT_4))) == 1:
        c4 = 0
        if d4 == 0:
            text_1 = " Input 4 Open"	
            writing_input()
            if in_4_mail_open == 1:
                mail_text = text_mail_4_open
                sendmail()			
            d4 = 1
        #else:
            #pass	
	
# Вход 5===================================
	
    if (int(GPIO.digitalRead(INPUT_5))) == 0:   # контроль входа 5
        d5 = 0
        if c5 == 0:
            text_1 = " Input 5 Close"	
            writing_input()
            if in_5_mail_close == 1:
                mail_text = text_mail_5_close
                sendmail()			
            c5 = 1
        #else:
            #pass	
		
    if (int(GPIO.digitalRead(INPUT_5))) == 1:
        c5 = 0
        if d5 == 0:
            text_1 = " Input 5 Open"	
            writing_input()
            if in_5_mail_open == 1:
                mail_text = text_mail_5_open
                sendmail()				
            d5 = 1
        #else:
            #pass		
	
# Вход 6===================================
	
    if (int(GPIO.digitalRead(INPUT_6))) == 0:   # контроль входа 6
        d6 = 0
        if c6 == 0:
            text_1 = " Input 6 Close"	
            writing_input()
            if in_6_mail_close == 1:
                mail_text = text_mail_6_close
                sendmail()			
            c6 = 1
        #else:
            #pass	
		
    if (int(GPIO.digitalRead(INPUT_6))) == 1:
        c6 = 0
        if d6 == 0:
            text_1 = " Input 6 Open"	
            writing_input()
            if in_6_mail_open == 1:
                mail_text = text_mail_6_open
                sendmail()			
            d6 = 1
        #else:
            #pass	
	
# Вход 7===================================
    if on_in_7 == 0:
        if (int(GPIO.digitalRead(INPUT_7))) == 0:   # контроль входа 7
            d7 = 0
            if c7 == 0:
                text_1 = " Input 7 Close"	
                writing_input()
                if in_7_mail_close == 1:
                    mail_text = text_mail_7_close
                    sendmail()				
                c7 = 1
	
    if on_in_7 == 0:		
        if (int(GPIO.digitalRead(INPUT_7))) == 1:
            c7 = 0
            if d7 == 0:
                text_1 = " Input 7 Open"	
                writing_input()
                if in_7_mail_open == 1:
                    mail_text = text_mail_7_open
                    sendmail()				
                d7 = 1
    else:
        pass		
	
# Вход 8===================================
	
    if on_in_8 == 0:
        if (int(GPIO.digitalRead(INPUT_8))) == 0:   # контроль входа 8
            d8 = 0
            if c8 == 0:
                text_1 = " Input 8 Close"	
                writing_input()
                if in_8_mail_close == 1:
                    mail_text = text_mail_8_close
                    sendmail()				
                c8 = 1
	
    if on_in_8 == 0:		
        if (int(GPIO.digitalRead(INPUT_8))) == 1:
            c8 = 0
            if d8 == 0:
                text_1 = " Input 8 Open"	
                writing_input()
                if in_8_mail_open == 1:
                    mail_text = text_mail_8_open
                    sendmail()				
                d8 = 1
    else:
        pass		
	


	
# =================================КОНТРОЛЬ ВХОДОВ 7 И 8 С ПРИВЯЗКОЙ К ВЫХОДАМ 7 И 8	
	
    global e7, f7, e8, f8
	
# Вход 7+++++===================================
    if on_in_7 == 1:	
	
        if (int(GPIO.digitalRead(INPUT_7))) == 0:   		# контроль входа 7 с включением реле
            f7 = 0
            value = int(0)		
            GPIO.digitalWrite(25,value)          		# записать в порт OUT_7 значение value 
            if e7 == 0:
                text_1 = " Input 7 Close / Relay 7 ON"	
                writing_input()
                if in_7_mail_close == 1:
                    mail_text = text_mail_7_close				
                    sendmail()
                e7 = 1
    else:
        pass	
		
		
    if on_in_7 == 1:
	
        if (int(GPIO.digitalRead(INPUT_7))) == 1:   		# контроль входа 7 с включением реле
            e7 = 0
            value = int(1)		
            GPIO.digitalWrite(25,value)          		# записать в порт OUT_7 значение value 
            if f7 == 0:
                text_1 = " Input 7 Open  / Relay 7 OFF"	
                writing_input()
                if in_7_mail_open == 1:
                    mail_text = text_mail_7_open
                    sendmail()
                f7 = 1
    else:
        pass		
		

		

# Вход 8+++++===================================

    if on_in_8 == 1:
	
        if (int(GPIO.digitalRead(INPUT_8))) == 0:   		# контроль входа 8 с включением реле
            f8 = 0
            value = int(0)		
            GPIO.digitalWrite(24,value)          		# записать в порт OUT_8 значение value 
            if e8 == 0:
                text_1 = " Input 8 Close / Relay 8 ON"	
                writing_input()
                if in_8_mail_close == 1:
                    mail_text = text_mail_8_close
                    sendmail()
                e8 = 1
    else:
        pass	
		
		
    if on_in_8 == 1:	
		
        if (int(GPIO.digitalRead(INPUT_8))) == 1:   		# контроль входа 8 с включением реле
            e8 = 0
            value = int(1)		
            GPIO.digitalWrite(24,value)          		# записать в порт OUT_8 значение value 
            if f8 == 0:
                text_1 = " Input 8 Open  / Relay 8 OFF"	
                writing_input()
                if in_8_mail_open == 1:
                    mail_text = text_mail_8_open
                    sendmail()
                f8 = 1
    else:
        pass			

	
	
#============================ КОНТРОЛЬ ВЫХОДОВ (для записи в журнал событий) ====================================	

    global text_1, a1, b1, a2, b2, a3, b3, a4, b4, a5, b5, a6, b6, a7, b7, a8, b8


# Выход 1+контроль привязки к термостату ===================================
	
    if on_t_1 == 0:
	
        if (int(GPIO.digitalRead(OUT_1))) == 0:  
            b1 = 0	
            if a1 == 0:
                text_1 = " Relay 1 ON "	
                writing_out()	
                a1 = 1
		

    if on_t_1 == 0:
	
        if (int(GPIO.digitalRead(OUT_1))) == 1:
            a1 = 0	
            if b1 == 0:
                text_1 = " Relay 1 OFF"	
                writing_out()	
                b1 = 1	
    else:
        pass	
		 
		 
# Выход 2+контроль привязки к термомтату ===================================

    if on_t_2 == 0:
		
        if (int(GPIO.digitalRead(OUT_2))) == 0:   
            b2 = 0	
            if a2 == 0:
                text_1 = " Relay 2 ON "	
                writing_out()	
                a2 = 1
				
    if on_t_2 == 0:
	
        if (int(GPIO.digitalRead(OUT_2))) == 1:
            a2 = 0	
            if b2 == 0:
                text_1 = " Relay 2 OFF"	
                writing_out()	
                b2 = 1	
    else:
        pass	
		 
# Выход 3 + таймер ===================================
	
    if (int(GPIO.digitalRead(OUT_3))) == 0: 
        b3 = 0	
        if a3 == 0:
            if time_1_on == 1:
                text_1 = " Relay 3 ON  / Timer start"
            else:
                text_1 = " Relay 3 ON"				
            writing_out()	
            a3 = 1
			
    if (int(GPIO.digitalRead(OUT_3))) == 1:
        a3 = 0	
        if b3 == 0:
            if time_1_on == 1:
                text_1 = " Relay 3 OFF / Timer stop"	
            else:
                text_1 = " Relay 3 OFF"	
            writing_out()	
            b3 = 1			 
		 
# Выход 4 + таймер ===================================
	
    if (int(GPIO.digitalRead(OUT_4))) == 0: 
        b4 = 0	
        if a4 == 0:
            if time_2_on == 1:
                text_1 = " Relay 4 ON  / Timer start"
            else:
                text_1 = " Relay 4 ON"	
            writing_out()	
            a4 = 1
			
    if (int(GPIO.digitalRead(OUT_4))) == 1:
        a4 = 0	
        if b4 == 0:
            if time_2_on == 1:
                text_1 = " Relay 4 OFF / Timer stop"	
            else:
                text_1 = " Relay 4 OFF"	
            writing_out()	
            b4 = 1			 
	 
	 
# Выход 5 + люксметр ===================================

    if on_lux_1 == 0:	
        if (int(GPIO.digitalRead(OUT_5))) == 0: 
            b5 = 0	
            if a5 == 0:
                text_1 = " Relay 5 ON "	
                writing_out()	
                a5 = 1

    if on_lux_1 == 0:					
        if (int(GPIO.digitalRead(OUT_5))) == 1:
            a5 = 0	
            if b5 == 0:
                text_1 = " Relay 5 OFF"	
                writing_out()	
                b5 = 1		 
	 
	 
# Выход 6 ===================================
	
    if (int(GPIO.digitalRead(OUT_6))) == 0: 
        b6 = 0	
        if a6 == 0:
            text_1 = " Relay 6 ON"	
            writing_out()	
            a6 = 1
			
    if (int(GPIO.digitalRead(OUT_6))) == 1:
        a6 = 0	
        if b6 == 0:
            text_1 = " Relay 6 OFF"	
            writing_out()	
            b6 = 1		 

# Выход 7+контроль привязки к входу 7 ===================================
	
    if (int(GPIO.digitalRead(OUT_7))) == 0: 
        b7 = 0	
        if a7 == 0:
            if on_in_7 == 0:
                text_1 = " Relay 7 ON"	
                writing_out()	
                a7 = 1

            if on_in_7 == 1:
                #text_1 = " Relay 7 ON  / Input 7 Close"	
                #writing_out()	
                a7 = 1
				
			
    if (int(GPIO.digitalRead(OUT_7))) == 1:
        a7 = 0	
        if b7 == 0:
            if on_in_7 == 0:
                text_1 = " Relay 7 OFF"	
                writing_out()	
                b7 = 1		

            if on_in_7 == 1:
                #text_1 = " Relay 7 OFF / Input 7 Open"	
                #writing_out()	
                b7 = 1	 
	 
    else:
        pass
	 
	 
	 
	 
	 
	 
# Выход 8+контроль привязки к входу 8 ===================================
	
    if (int(GPIO.digitalRead(OUT_8))) == 0: 
        b8 = 0	
        if a8 == 0:
            if on_in_8 == 0:
                text_1 = " Relay 8 ON"	
                writing_out()	
                a8 = 1
			
            if on_in_8 == 1:
                #text_1 = " Relay 8 ON  / Input 8 Close"	
                #writing_out()	
                a8 = 1			
			
			
			
			
			
    if (int(GPIO.digitalRead(OUT_8))) == 1:
        a8 = 0	
        if b8 == 0:
            if on_in_8 == 0:
                text_1 = " Relay 8 OFF"	
                writing_out()	
                b8 = 1		 

            if on_in_8 == 1:
                #text_1 = " Relay 8 OFF / Input 8 Open"	
                #writing_out()	
                b8 = 1							
				
    else:
        pass		
	
	
	

	

#============================ ТЕРМОСТАТ НА ! и 2 ВЫХОДАХ =======================

    global celsius_1, celsius_2, temp_log, e1, e2, e3, e4, f1, f2, f3, f4
	

	
#============================ ПЕРВЫЙ ДАТЧИК	ТЕРМОСТАТА РЕЛЕ К1
    if on_t_1 == 1:
        celsius_1 = tmp1.getCelsius() 
        celsius_1 = float(celsius_1)	
        if celsius_1 < min_t_1: 
            GPIO.digitalWrite(21, GPIO.LOW)
            f1 = 0
            if e1 == 0:
                text_1 = " Relay 1 ON  / Temperature"	
                temp_log = celsius_1
                writing_temp()
                #sendmail()							# вызов процедуры посылки письма
                e1 = 1
    else:
        pass		

    if on_t_1 == 1:	
        celsius_1 = tmp1.getCelsius() 
        celsius_1 = float(celsius_1)	
        if celsius_1 > max_t_1: 
            GPIO.digitalWrite(21, GPIO.HIGH)
            e1 = 0
            if f1 == 0:
                text_1 = " Relay 1 OFF / Temperature"
                temp_log = celsius_1			
                writing_temp()
                #sendmail()							
                f1 = 1
    else:
        pass
	
#============================ ВТОРОЙ ДАТЧИК	ТЕРМОСТАТА РЕЛЕ К2

    if on_t_2 == 1:	
        celsius_2 = tmp2.getCelsius() 
        celsius_2 = float(celsius_2)	
        if celsius_2 < min_t_2: 
            GPIO.digitalWrite(20, GPIO.LOW)
            f2 = 0
            if e2 == 0:
                text_1 = " Relay 2 ON  / Temperature"	
                temp_log = celsius_2
                writing_temp()
                #sendmail()							
                e2 = 1
    else:
        pass		

	
    if on_t_2 == 1:	
        celsius_2 = tmp2.getCelsius() 
        celsius_2 = float(celsius_2)	
        if celsius_2 > max_t_2: 
            GPIO.digitalWrite(20, GPIO.HIGH)
            e2 = 0
            if f2 == 0:
                text_1 = " Relay 2 OFF / Temperature"
                temp_log = celsius_2			
                writing_temp()
                #sendmail()							
                f2 = 1
    else:
        pass	
	
	

	
#============  ПЕРВЫЙ ТАЙМЕР РЕЛЕ К3	
	
    if time_1_on == 1:
	
        now = datetime.datetime.now()

        if ((now.hour == hour_1_start) and (now.minute >= minute_1_start)):		    
            GPIO.digitalWrite(16, GPIO.LOW)
					
        if ((now.hour == hour_1_stop) and (now.minute >= minute_1_stop)):		    
            GPIO.digitalWrite(16, GPIO.HIGH)
				
    else:
        pass	
	
	
	
#============  ВТРОЙ ТАЙМЕР РЕЛЕ К4	
	
    if time_2_on == 1:
	
        now = datetime.datetime.now()

        if ((now.hour == hour_2_start) and (now.minute >= minute_2_start)):		    
            GPIO.digitalWrite(12, GPIO.LOW)			

        if ((now.hour == hour_2_stop) and (now.minute >= minute_2_stop)):	    
            GPIO.digitalWrite(12, GPIO.HIGH)
					
    else:
        pass	
	
	

	
	
#============================ ЛЮКСМЕТР РЕЛЕ К5

    global lux_1, lux_2, lux_log, j1, k1, j2, k2 
    #lux_1 = light0.getLux() 						# получение освещения 
    #print (lux_1)



    if on_lux_1 == 1:
        lux_1 = light0.getLux() 	
        if lux_1 < min_lux_1:
            time.sleep(0.250)		
        if lux_1 < min_lux_1:
            GPIO.digitalWrite(7, GPIO.LOW)
            k1 = 0
		
            if j1 == 0:
                text_1 = " Relay 5 ON  / Lux"	
                lux_log = lux_1
                writing_lux()
                #sendmail()							# вызов процедуры посылки письма
                j1 = 1
    else:
        pass		

    if on_lux_1 == 1:
        lux_1 = light0.getLux() 	
        if lux_1 > max_lux_1: 
            time.sleep(0.250)
        if lux_1 > max_lux_1:			
            GPIO.digitalWrite(7, GPIO.HIGH)
            j1 = 0
		
            if k1 == 0:
                text_1 = " Relay 5 OFF / Lux"
                lux_log = lux_1			
                writing_lux()
                #sendmail()							
                k1 = 1
    else:
        pass	


	
    webiopi.sleep(0.5)
	

#======================================МАКРОСЫ e-Mail===========================

@webiopi.macro
def sendmail():
 
    smtp_port = 587	
    mail_subj = 'Web Home Pi message'	# тема письма
    mail_coding = 'windows-1251'
    attach_file = '/home/pi/myproject/html/logs/log_gpio.txt' # прикрепляемый файл	
	
    
    # формирование сообщения
    try:
        multi_msg = MIMEMultipart()
        multi_msg['From'] = Header(mail_from, mail_coding)
        multi_msg['To'] = Header(mail_to, mail_coding)
        multi_msg['Subject'] =  Header(mail_subj, mail_coding)
 
        msg = MIMEText(mail_text.encode('cp1251'), 'plain', mail_coding)
        msg.set_charset(mail_coding)
        multi_msg.attach(msg)

        # присоединяем атач-файл
        if(os.path.exists(attach_file) and os.path.isfile(attach_file)):
            file = open(attach_file, 'rb')
            attachment = MIMEBase('application', "octet-stream")
            attachment.set_payload(file.read())
            email.encoders.encode_base64(attachment)
            file.close()
            only_name_attach = Header(os.path.basename(attach_file),mail_coding);
            attachment.add_header('Content-Disposition','attachment; filename="%s"' % only_name_attach)
            multi_msg.attach(attachment)
        else:
            if(attach_file.lstrip() != ""):
                print("Файл для атача не найден - " + attach_file)	
	
        # отправка
        smtp = smtplib.SMTP(smtp_server, smtp_port)
        smtp.ehlo()
        smtp.starttls()
        smtp.ehlo()
        smtp.login(smtp_user, smtp_pwd)
        smtp.sendmail(mail_from, mail_to, multi_msg.as_string())
        smtp.quit()	

	
    except IOError:
        pass
    except Exception as e:
        pass
		
	
#==============================================================
# Запись cостояния выходов при работе термостата
@webiopi.macro
def writing_temp():
    print(text_1)
    f = open('/home/pi/myproject/html/logs/log_gpio.txt', 'a')
    data_entry = "{0},{1},{2}\n".format(strftime("%d-%m-%Y %H:%M:%S"),text_1,temp_log)
    f.write(data_entry)
    f.close()

# Запись cостояния выходов при работе люксметра
def writing_lux():
    print(text_1)
    f = open('/home/pi/myproject/html/logs/log_gpio.txt', 'a')
    data_entry = "{0},{1},{2}\n".format(strftime("%d-%m-%Y %H:%M:%S"),text_1, "%.1f" % lux_log)
    f.write(data_entry)
    f.close()
	
# Запись cостояния входов
@webiopi.macro
def writing_input():
    print(text_1)
    f = open('/home/pi/myproject/html/logs/log_gpio.txt', 'a')
    data_entry = "{0},{1}\n".format(strftime("%d-%m-%Y %H:%M:%S"),text_1)
    f.write(data_entry)
    f.close()

	
# Запись cостояния выходов
@webiopi.macro
def writing_out():
    print(text_1)
    f = open('/home/pi/myproject/html/logs/log_gpio.txt', 'a')
    data_entry = "{0},{1}\n".format(strftime("%d-%m-%Y %H:%M:%S"),text_1)
    f.write(data_entry)
    f.close()	
	
	
	
	
	
	

#======================================МАКРОСЫ ВВОДА И ЧТЕНИЯ ДАННЫХ КОНФИГУРАЦИИ===========================

#=========== ввод данных конфигурации

@webiopi.macro	
def getMinMax(ust_1_on,ust_1_min,ust_1_max,ust_2_on,ust_2_min,ust_2_max,on_out_7,on_out_8,\
    in_1_mail_close,in_1_mail_open,in_2_mail_close,in_2_mail_open,in_3_mail_close,in_3_mail_open,in_4_mail_close,in_4_mail_open,\
    in_5_mail_close,in_5_mail_open,in_6_mail_close,in_6_mail_open,in_7_mail_close,in_7_mail_open,in_8_mail_close,in_8_mail_open,\
    time_1_on,time_1_start,time_1_stop,time_2_on,time_2_start,time_2_stop,lux_1_on,lux_1_start,lux_1_stop,\
    sensor_1,sensor_2,sensor_3,sensor_4,sensor_5,sensor_6,sensor_7,sensor_8,\
    sensor_9,sensor_10,sensor_11,sensor_12,sensor_13,sensor_14,sensor_15,sensor_16,\
    id_18b20_1,id_18b20_2,id_18b20_3,id_18b20_4,id_18b20_5,id_18b20_6,id_18b20_7,id_18b20_8,id_18b20_9,id_18b20_10,\
    text_mail_1_close,text_mail_1_open,text_mail_2_close,text_mail_2_open,text_mail_3_close,text_mail_3_open,text_mail_4_close,text_mail_4_open,\
    text_mail_5_close,text_mail_5_open,text_mail_6_close,text_mail_6_open,text_mail_7_close,text_mail_7_open,text_mail_8_close,text_mail_8_open,\
    mail_to,mail_from,smtp_server,smtp_user,smtp_pwd,\
    reserve,ch_1,ch_2,ch_3,ch_4,ch_5,ch_6,ch_7,ch_8): 
	
    f = open('/home/pi/myproject/html/logs/config.txt', 'w')
    f.write((ust_1_on) + "\n")
    f.write((ust_1_min) + "\n")	
    f.write((ust_1_max) + "\n")	
    f.write((ust_2_on) + "\n")
    f.write((ust_2_min) + "\n")	
    f.write((ust_2_max) + "\n")		
    f.write((on_out_7) + "\n")		
    f.write((on_out_8) + "\n")	
	
    f.write((in_1_mail_close) + "\n")		
    f.write((in_1_mail_open) + "\n")		
    f.write((in_2_mail_close) + "\n")		
    f.write((in_2_mail_open) + "\n")
    f.write((in_3_mail_close) + "\n")		
    f.write((in_3_mail_open) + "\n")		
    f.write((in_4_mail_close) + "\n")		
    f.write((in_4_mail_open) + "\n")

    f.write((in_5_mail_close) + "\n")		
    f.write((in_5_mail_open) + "\n")		
    f.write((in_6_mail_close) + "\n")		
    f.write((in_6_mail_open) + "\n")
    f.write((in_7_mail_close) + "\n")		
    f.write((in_7_mail_open) + "\n")		
    f.write((in_8_mail_close) + "\n")		
    f.write((in_8_mail_open) + "\n")
	
    f.write((time_1_on) + "\n")	
    f.write((time_1_start) + "\n")	
    f.write((time_1_stop) + "\n")

    f.write((time_2_on) + "\n")	
    f.write((time_2_start) + "\n")	
    f.write((time_2_stop) + "\n")

    f.write((lux_1_on) + "\n")	
    f.write((lux_1_start) + "\n")	
    f.write((lux_1_stop) + "\n")
	
    f.write((sensor_1) + "\n")	
    f.write((sensor_2) + "\n")	
    f.write((sensor_3) + "\n")	
    f.write((sensor_4) + "\n")	
    f.write((sensor_5) + "\n")	
    f.write((sensor_6) + "\n")	
    f.write((sensor_7) + "\n")	
    f.write((sensor_8) + "\n")
    f.write((sensor_9) + "\n")	
    f.write((sensor_10) + "\n")	
    f.write((sensor_11) + "\n")	
    f.write((sensor_12) + "\n")	
    f.write((sensor_13) + "\n")	
    f.write((sensor_14) + "\n")	
    f.write((sensor_15) + "\n")	
    f.write((sensor_16) + "\n")	
	
    f.write((id_18b20_1) + "\n")
    f.write((id_18b20_2) + "\n")	
    f.write((id_18b20_3) + "\n")
    f.write((id_18b20_4) + "\n")	
    f.write((id_18b20_5) + "\n")
    f.write((id_18b20_6) + "\n")
    f.write((id_18b20_7) + "\n")
    f.write((id_18b20_8) + "\n")
    f.write((id_18b20_9) + "\n")
    f.write((id_18b20_10) + "\n")	
	
    f.write((text_mail_1_close) + "\n")	
    f.write((text_mail_1_open) + "\n")	
    f.write((text_mail_2_close) + "\n")	
    f.write((text_mail_2_open) + "\n")	
    f.write((text_mail_3_close) + "\n")	
    f.write((text_mail_3_open) + "\n")	
    f.write((text_mail_4_close) + "\n")	
    f.write((text_mail_4_open) + "\n")			
    f.write((text_mail_5_close) + "\n")	
    f.write((text_mail_5_open) + "\n")	
    f.write((text_mail_6_close) + "\n")	
    f.write((text_mail_6_open) + "\n")		
    f.write((text_mail_7_close) + "\n")	
    f.write((text_mail_7_open) + "\n")	
    f.write((text_mail_8_close) + "\n")	
    f.write((text_mail_8_open) + "\n")		
	
    f.write((mail_to) + "\n")		
    f.write((mail_from) + "\n")	
    f.write((smtp_server) + "\n")	
    f.write((smtp_user) + "\n")	
    f.write((smtp_pwd) + "\n")	
	
    f.write((reserve) + "\n")
		
    f.write((ch_1) + "\n")		
    f.write((ch_2) + "\n")	
    f.write((ch_3) + "\n")	
    f.write((ch_4) + "\n")	
    f.write((ch_5) + "\n")	
    f.write((ch_6) + "\n")	
    f.write((ch_7) + "\n")	
    f.write((ch_8) + "\n")	
    f.close()
	
    setup()		
    set_out()
	  





#=========== чтение данных конфигурации


@webiopi.macro
def getRead():
    f = open('/home/pi/myproject/html/logs/config.txt', 'r')
    global i0,i1,i2,i3,i4,i5,i6,i7,i8,i9,i10,i11,i12,i13,i14,i15,i16,i17,i18,i19,i20,i21,i22,i23,i24,i25,i26,i27,i28,i29,i30,\
    i31,i32,i33,i34,i35,i36,i37,i38,i39,i40,i41,i42,i43,i44,i45,i46,i47,i48,i49,i50,i51,i52,i53,i54,i55,i56,i57,i58,i59,i60,\
    i61,i62,i63,i64,i65,i66,i67,i68,i69,i70,i71,i72,i73,i74,i75,i76,i77,i78,i79,i80,i81,i82,i83,i84,i85,i86,i87,i88
	
    i0 = f.readline()	
    i1 = f.readline()	
    i2 = f.readline()
	
    i3 = f.readline()
    i4 = f.readline()	
    i5 = f.readline()
	
    i6 = f.readline()		
    i7 = f.readline()

    i8 = f.readline()	
    i9 = f.readline()	
    i10 = f.readline()	
    i11 = f.readline()
    i12 = f.readline()	
    i13 = f.readline()		
    i14 = f.readline()		
    i15 = f.readline()
    i16 = f.readline()	
    i17 = f.readline()	
    i18 = f.readline()	
    i19 = f.readline()
    i20 = f.readline()	
    i21 = f.readline()		
    i22 = f.readline()		
    i23 = f.readline()
	
    i24 = f.readline()		
    i25 = f.readline()		
    i26 = f.readline()	
	
    i27 = f.readline()		
    i28 = f.readline()		
    i29 = f.readline()		
	
    i30 = f.readline()		
    i31 = f.readline()		
    i32 = f.readline()	
	
    i33 = f.readline()	
    i34 = f.readline()		
    i35 = f.readline()		
    i36 = f.readline()		
    i37 = f.readline()		
    i38 = f.readline()		
    i39 = f.readline()		
    i40 = f.readline()	
	
    i41 = f.readline()	
    i42 = f.readline()		
    i43 = f.readline()		
    i44 = f.readline()		
    i45 = f.readline()		
    i46 = f.readline()		
    i47 = f.readline()		
    i48 = f.readline()
    i49 = f.readline()		
    i50 = f.readline()

    i51 = f.readline()	
    i52 = f.readline()		
    i53 = f.readline()		
    i54 = f.readline()		
    i55 = f.readline()		
    i56 = f.readline()		
    i57 = f.readline()		
    i58 = f.readline()
    i59 = f.readline()		
    i60 = f.readline()	

    i61 = f.readline()	
    i62 = f.readline()		
    i63 = f.readline()		
    i64 = f.readline()		
    i65 = f.readline()		
    i66 = f.readline()		
    i67 = f.readline()		
    i68 = f.readline()
    i69 = f.readline()		
    i70 = f.readline()	

    i71 = f.readline()	
    i72 = f.readline()		
    i73 = f.readline()		
    i74 = f.readline()		
    i75 = f.readline()		
    i76 = f.readline()		
    i77 = f.readline()		
    i78 = f.readline()
    i79 = f.readline()		

    i80 = f.readline()
	
    i81 = f.readline()
    i82 = f.readline()
    i83 = f.readline()
    i84 = f.readline()
    i85 = f.readline()
    i86 = f.readline()
    i87 = f.readline()
    i88 = f.readline()	

    f.close()
    lista = i0,i1,i2,i3,i4,i5,i6,i7,i8,i9,i10,i11,i12,i13,i14,i15,i16,i17,i18,i19,i20,i21,i22,i23,i24,i25,i26,i27,i28,i29,i30,\
    i31,i32,i33,i34,i35,i36,i37,i38,i39,i40,i41,i42,i43,i44,i45,i46,i47,i48,i49,i50,i51,i52,i53,i54,i55,i56,i57,i58,i59,i60,\
    i61,i62,i63,i64,i65,i66,i67,i68,i69,i70,i71,i72,i73,i74,i75,i76,i77,i78,i79,i80,i81,i82,i83,i84,i85,i86,i87,i88
    print("lista",lista)	
    return json.dumps (lista)
	
	
	

	
	
	
	
	
#=========== чтение напоминаний	
	
@webiopi.macro		
def getMessage():
    f = open('/home/pi/myproject/html/logs/message.txt', 'r')
    global message_1 	
    if time_1_on == 1:	
        now = datetime.datetime.now()
        if ((now.hour == hour_1_start) and (now.minute >= minute_1_start)):		    
            message_1 = f.readline()
            f.close()	
            print(message_1)	
            return message_1			
    else:
        pass	




#=========== чтение журнала
	
@webiopi.macro		
def getLogs():
    #f = open('/home/pi/myproject/html/logs/log_gpio.txt', 'r')
    global logs_gpio	
  		    
    #logs_gpio = f.readlines()
    #f.close()	
    #print(logs_gpio)	
    #return logs_gpio			

    #with open("/home/pi/myproject/html/logs/log_gpio.txt") as file:
        #logs_gpio =[row.strip() for row in file]
        #print(logs_gpio)	
        #return logs_gpio	


    f = open('/home/pi/myproject/html/logs/log_gpio.txt')
    #i = 100
    #while i > 10:
    logs_gpio = f.readlines()
    print(logs_gpio)
    return logs_gpio
		 
	
    f.close()

	
	
	
	
	
# ============== очистка журналов логов

@webiopi.macro	
def clear_log_gpio():
    f = open('/home/pi/myproject/html/logs/log_gpio.txt', 'w')	
    f.write()		
    f.close()	
	

# ============== рестарт webiopi
@webiopi.macro
def restart_webiopi():
    os.system("sudo systemctl restart webiopi.service")		
